Create /var/run/iodine in init script if it doesn't exist; thanks to
[debian/iodine.git] / debian / iodine.iodined.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          iodined
4 # Required-Start:    $remote_fs $network
5 # Required-Stop:     $remote_fs $network
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: initscript for iodined
9 # Description:       initscript for iodined
10 ### END INIT INFO
11
12 # Author: gregor herrmann <gregor+debian@comodo.priv.at>
13
14 # Do NOT "set -e"
15
16 # PATH should only include /usr/* if it runs after the mountnfs.sh script
17 PATH=/sbin:/usr/sbin:/bin:/usr/bin
18 DESC="IP over DNS tunneling server"
19 NAME=iodined
20 DAEMON=/usr/sbin/$NAME
21 DEFAULT=iodine
22 DAEMON_ARGS=""
23 PIDFILE=/var/run/$NAME.pid
24 SCRIPTNAME=/etc/init.d/$NAME
25 CHROOTDIR=/var/run/iodine
26
27 # Exit if the package is not installed
28 [ -x "$DAEMON" ] || exit 0
29
30 # Read configuration variable file or exit
31 [ -r /etc/default/$DEFAULT ] || exit 0
32 . /etc/default/$DEFAULT
33
34 # Load the VERBOSE setting and other rcS variables
35 . /lib/init/vars.sh
36
37 # Define LSB log_* functions.
38 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
39 . /lib/lsb/init-functions
40
41 # Get config
42 get_config() {
43         if [ "$START_IODINED" != "true" ] ; then
44                 [ "$VERBOSE" != no ] && log_progress_msg "- automatic start disabled" && log_end_msg 0
45                 exit 0
46         else
47                 if [ -n "$IODINED_ARGS" ] && [ -n "$IODINED_PASSWORD" ] ; then
48                         DAEMON_ARGS="-u iodine -t $CHROOTDIR -P $IODINED_PASSWORD $IODINED_ARGS"
49                 else
50                         [ "$VERBOSE" != no ] && log_warning_msg "$NAME is not fully configured. Change this in /etc/default/$DEFAULT or run dpkg-reconfigure $DEFAULT."
51                         exit 0
52                 fi
53         fi
54 }
55
56 # chroot dir
57 check_chrootdir() {
58         if [ -d "$CHROOTDIR" ] || mkdir -p "$CHROOTDIR" ; then
59                 return 0
60         else
61                 [ "$VERBOSE" != no ] && log_failure_msg "$CHROOTDIR does not exist and can't be created."
62                 exit 0
63         fi
64 }       
65
66 #
67 # Function that starts the daemon/service
68 #
69 do_start()
70 {
71         # populate $DAEMON_ARGS
72         get_config
73         # check CHROOTDIR
74         check_chrootdir
75         # 
76         # Return
77         #   0 if daemon has been started
78         #   1 if daemon was already running
79         #   2 if daemon could not be started
80         start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
81                 || return 1
82         start-stop-daemon --start --quiet --exec $DAEMON -- $DAEMON_ARGS \
83                 || return 2
84         # Add code here, if necessary, that waits for the process to be ready
85         # to handle requests from services started subsequently which depend
86         # on this one.  As a last resort, sleep for some time.
87 }
88
89 #
90 # Function that stops the daemon/service
91 #
92 do_stop()
93 {
94         # Return
95         #   0 if daemon has been stopped
96         #   1 if daemon was already stopped
97         #   2 if daemon could not be stopped
98         #   other if a failure occurred
99         start-stop-daemon --stop --quiet --retry=TERM/5/KILL/5 --exec $DAEMON
100         RETVAL="$?"
101         [ "$RETVAL" = 2 ] && return 2
102         # Wait for children to finish too if this is a daemon that forks
103         # and if the daemon is only ever run from this initscript.
104         # If the above conditions are not satisfied then add some other code
105         # that waits for the process to drop all resources that could be
106         # needed by services started subsequently.  A last resort is to
107         # sleep for some time.
108         start-stop-daemon --stop --quiet --oknodo --retry=0/5/KILL/5 --exec $DAEMON
109         [ "$?" = 2 ] && return 2
110         # Many daemons don't delete their pidfiles when they exit.
111         rm -f $PIDFILE
112         return "$RETVAL"
113 }
114
115 case "$1" in
116   start)
117         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
118         do_start
119         case "$?" in
120                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
121                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
122         esac
123         ;;
124   stop)
125         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
126         do_stop
127         case "$?" in
128                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
129                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
130         esac
131         ;;
132   restart|force-reload)
133         log_daemon_msg "Restarting $DESC" "$NAME"
134         do_stop
135         case "$?" in
136           0|1)
137                 do_start
138                 case "$?" in
139                         0) log_end_msg 0 ;;
140                         1) log_end_msg 1 ;; # Old process is still running
141                         *) log_end_msg 1 ;; # Failed to start
142                 esac
143                 ;;
144           *)
145                 # Failed to stop
146                 log_end_msg 1
147                 ;;
148         esac
149         ;;
150   *)
151         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
152         exit 3
153         ;;
154 esac
155
156 :